/*****************************************************************************************************

	MCD05.cpp : class MCD05 Ver.2.1

	
													2015.7.28 M.Utsumi@ARCDEVICE 

******************************************************************************************************/

#include<windows.h>
#include<stdio.h>
#include<math.h>
#include"MCD05.h"

MCD05::MCD05()
{
	CheckSumEnable = TRUE;
}

MCD05::~MCD05()
{

}

BOOL MCD05::ClearData( void )
{
	return( Transceive( MCD05_CLEAR_DATA, NULL, 0, NULL, 0 ) );
}


BOOL MCD05::Exchange( void* pOutputData, void* pInputData, BOOL RightNow )
{
	return( Transceive( MCD05_EXCHANGE, pOutputData, sizeof( MCD05_OUTPUT ), pInputData, sizeof( MCD05_INPUT ), RightNow ) );
}

BOOL MCD05::Exchange( BOOL RightNow )
{

	if( !Transceive( MCD05_EXCHANGE, &OutputData, sizeof( MCD05_OUTPUT ), &InputData, sizeof(MCD05_INPUT), RightNow ) ) return( FALSE );

	return( TRUE );
}


BOOL MCD05::Receive( BYTE *pRxBuffer, WORD wSize )
{
	if( wSize != wReqRxSize ){
		sprintf_s( Error, "Rx Data size miss match %d %d\r\n", wReqRxSize,wSize );
		
		if( CheckSumEnable ){
			wSize--; // sub checksum;

			if( wSize == 0 ){
				bStatus = pRxBuffer[0];
				return( FALSE );
			}
		}
		bStatus = pRxBuffer[wSize-1];
		return( FALSE );
	}
	
	if( CheckSumEnable ){
		wSize--; // -CheckSum
		if(!CheckSum( pRxBuffer, wSize )){
			bStatus = CM_REPLY_SUM_ERROR;
			return( FALSE );
		}
	}
	wSize--; // sub status;
			
	if( wSize > 0 )	memcpy( pReserveBuffer, pRxBuffer, wSize );
	
	bStatus = pRxBuffer[wSize];
	
	if( bStatus!=CM_NORMAL ) return( FALSE );

	return( TRUE );
}

